# assumes the block at my feet is a container (chest/barrel) containing settings
# Item counts in Col. 1:
#  _ = unchanged
#  1 = set
#  2 = set to -val
#  3 = add
#  4 = subtract

tag @s add cre8appliedsettings

data modify storage cre8 SettingsItems set from block ~ ~ ~ Items

scoreboard players set settingsSlot cre8temp 0
scoreboard players set settingsSpeedMode cre8temp 0
scoreboard players set settingsSpeedVal1 cre8temp 0
scoreboard players set settingsSpeedVal2 cre8temp 0
scoreboard players set settingsHeightdiffMode cre8temp 0
scoreboard players set settingsHeightdiffVal1 cre8temp 0
scoreboard players set settingsHeightdiffVal2 cre8temp 0
scoreboard players set settingsRotdiffMode cre8temp 0
scoreboard players set settingsRotdiffVal1 cre8temp 0
scoreboard players set settingsRotdiffVal2 cre8temp 0

# this iterates over all the items
execute if data storage cre8 SettingsItems[0] run function cre8:ctick_apply_setting_one

# apply settings

## Speed
scoreboard players operation settingsSpeedVal1 cre8temp *= sixtyfour cre8temp
scoreboard players operation settingsSpeedVal1 cre8temp += settingsSpeedVal2 cre8temp
execute if score settingsSpeedMode cre8temp matches 1 run scoreboard players operation @s cre8speed = settingsSpeedVal1 cre8temp
execute if score settingsSpeedMode cre8temp matches 2 run scoreboard players set @s cre8speed 0
execute if score settingsSpeedMode cre8temp matches 3 run scoreboard players operation @s cre8speed += settingsSpeedVal1 cre8temp
execute if score settingsSpeedMode cre8temp matches 4 run scoreboard players operation @s cre8speed -= settingsSpeedVal1 cre8temp
execute if score @s cre8speed matches ..-1 run scoreboard players set @s cre8speed 0

## Heightdiff
scoreboard players operation settingsHeightdiffVal1 cre8temp *= sixtyfour cre8temp
scoreboard players operation settingsHeightdiffVal1 cre8temp += settingsHeightdiffVal2 cre8temp
execute if score settingsHeightdiffMode cre8temp matches 1..2 run scoreboard players operation @s cre8heightdiff = settingsHeightdiffVal1 cre8temp
execute if score settingsHeightdiffMode cre8temp matches 2 run scoreboard players operation @s cre8heightdiff *= minusone cre8temp
execute if score settingsHeightdiffMode cre8temp matches 3 run scoreboard players operation @s cre8heightdiff += settingsHeightdiffVal1 cre8temp
execute if score settingsHeightdiffMode cre8temp matches 4 run scoreboard players operation @s cre8heightdiff -= settingsHeightdiffVal1 cre8temp

## ROT: 3deg + 3/64deg (3*(64a+b))
scoreboard players operation settingsRotdiffVal1 cre8temp *= sixtyfour cre8temp
scoreboard players operation settingsRotdiffVal1 cre8temp += settingsRotdiffVal2 cre8temp
scoreboard players operation settingsRotdiffVal1 cre8temp *= three cre8temp
execute if score settingsRotdiffMode cre8temp matches 1..2 run scoreboard players operation @s cre8rotdiff = settingsRotdiffVal1 cre8temp
execute if score settingsRotdiffMode cre8temp matches 2 run scoreboard players operation @s cre8rotdiff *= minusone cre8temp
execute if score settingsRotdiffMode cre8temp matches 3 run scoreboard players operation @s cre8rotdiff += settingsRotdiffVal1 cre8temp
execute if score settingsRotdiffMode cre8temp matches 4 run scoreboard players operation @s cre8rotdiff -= settingsRotdiffVal1 cre8temp
